#ifndef TIXML_UTIL_H
#define TIXML_UTIL_H

#include "errhandling.h"
#include "wx/string.h"

#include <string>
#include <vector>

class TiXmlElement;


TiXmlElement *          tiwx_optionalChild(TiXmlElement* ancestor, wxString nodeName);
TiXmlElement *          tiwx_requiredChild(TiXmlElement* ancestor, wxString nodeName);
wxString                tiwx_nodeText(TiXmlElement *);
wxString                tiwx_attributeValue(TiXmlElement*,wxString attributeName);

double                  tiwx_double_from_text(TiXmlElement *);
long                    tiwx_long_from_text(TiXmlElement *) throw (incorrect_xml);
size_t                  tiwx_size_t_from_text(TiXmlElement *) throw (incorrect_xml);

std::vector<TiXmlElement *>  tiwx_optionalChildren(TiXmlElement* ancestor, wxString nodeName);
std::vector<TiXmlElement *>  tiwx_requiredChildren(TiXmlElement* ancestor, wxString nodeName);


#endif
// TIXML_UTIL_H
